(   Title:  Enhanced error display for otester
     File:  otester-errors.fs
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.3.3
  Revised:  February 16, 2012
)

VARIABLE OT-#ERRORS    0 OT-#ERRORS !
: OT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 OT-#ERRORS +! OT-ERROR-DEFAULT normal-text ;
\ ' OT-ERROR1 OT-ERROR-XT !

\ display results and goals
: ot-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i @ . -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: OT-ERROR2  ( c-addr u -- )
  OT-ERROR1
  OT-RESULTS s"   oresults: " ot-a.
  OT-GOALS   s"     ogoals: " ot-a. ;
\ ' XT-ERROR2 XT-ERROR-XT !

\ fancy results and goals display
: ot-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first 
       DO ( 'cells) i cells over + @
          i OT-ERROR-INDEX @ =
          IF red-text . blue-text ELSE . THEN
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: OT-ERROR3  ( c-addr u -- )
  OT-ERROR1
  OT-RESULTS s"   oresults: " ot-fancy-a.
  OT-GOALS   s"     ogoals: " ot-fancy-a. ;
' OT-ERROR3 OT-ERROR-XT !

: ?.ot-errors  ( -- )
  VERBOSE @ IF
  blue-text ." OT-ERRORS: " normal-text OT-#ERRORS @ . THEN ;
